//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/*
PIMS: Personal Invstment Management System
Class : PIMS
PIMS startup class. Contains the main method.
This class also instantiates the principle classes
these object references of is passed to the GUI,
class which uses these objects appropriately by interacting
with the user. The main classes instantiated are::
1> Data Repository
2> Investment
3> Alerts
4> Current Value System
5> Security Manager
6> GUI (Graphical Interface manager class)
*/
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

public class PIMS{
	public static void main(String args[])throws Exception{

		//Instantiation of the Data Repository class (database)
		dataRepository DR = new dataRepository();//Intantiation of the Data Repository class.

		//Instantiation of the Alerts class (alert manager)
		Alerts AL = new Alerts(DR);

		//Instantiation of the Security Manager Class
		SecurityManager SM = new SecurityManager(DR);

		//Instantiation of the Curent Value System class
		CurrentValueSystem CVS;
		if(args.length > 0 && args[0].equals("-d"))
			CVS = new CurrentValueSystem(DR, false);
		else if (args.length > 0 && args[0].equals("-p"))
			CVS = new CurrentValueSystem(DR);
		else
			CVS = new CurrentValueSystem(DR, true);
			
		//Instantiation of the Investment class
		Investment INV = new Investment(DR, CVS);

		//Instantiation of the GUI class (interface manager)
		GUI g=new GUI(DR, AL, SM, CVS, INV);
		
		//Start the login operation
		Login log = new Login(SM, g);
	}
}
